#define G_LOG_DOMAIN "gpod-feed-image"

#include "config.h"

#include <gdk/gdk.h>
#include <gtk/gtk.h>

GdkPixbuf *
gpod_feed_image_pixbuf_from_uri_full (gchar *uri,
                                      gint   width,
                                      gint   height)
{
    GdkPixbuf *image;
    GError *error = NULL;

    image = gdk_pixbuf_new_from_file_at_scale (uri, width, height, FALSE, &error);

    if (image == NULL)
    {
        g_warning ("%s", error->message);
        g_error_free (error);

        return gdk_pixbuf_new_from_resource (PACKAGE_RESOURCES "/icons/podcast.svg", NULL);
    }

    return image;
}

GtkWidget *
gpod_feed_image_from_uri_full (gchar *uri,
                               gint   width,
                               gint   height)
{
    GdkPixbuf *image;

    image = gpod_feed_image_pixbuf_from_uri_full (uri, width, height);

    return gtk_image_new_from_pixbuf (image);
}

GdkPixbuf *
gpod_feed_image_pixbuf_from_uri (gchar *uri)
{
    return gpod_feed_image_pixbuf_from_uri_full (uri, 128, 128);
}

GtkWidget *
gpod_feed_image_from_uri (gchar *uri)
{
    return gpod_feed_image_from_uri_full (uri, 128, 128);
}
