#ifndef __GPOD_PARSER_H__
#define __GPOD_PARSER_H__

#include "gpod-types.h"

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define GPOD_TYPE_PARSER (gpod_parser_get_type ())

G_DECLARE_FINAL_TYPE (GpodParser, gpod_parser, GPOD, PARSER, GObject)

struct _GpodParser
{
    GObject parent;
};

GpodParser *
gpod_parser_new ();

gboolean
gpod_parser_load_from_data (GpodParser  *self,
                            gchar       *data,
                            gssize       length,
                            GError     **error);

gboolean
gpod_parser_load_from_file (GpodParser  *self,
                            gchar       *filename,
                            GError     **error);

gboolean
gpod_parser_load_from_stream (GpodParser    *self,
                              GInputStream  *stream,
                              GCancellable  *cancellable,
                              GError       **error);

/*
 * Feed
 */
GpodFeed *
gpod_parser_get_feed (GpodParser *self);

/*
 * Channel
 */
GpodChannel *
gpod_parser_get_channel (GpodParser *self);

gpointer
gpod_parser_get_channel_element (GpodParser *self,
                                 gchar      *element);

gchar *
gpod_parser_get_channel_title (GpodParser *self);

gchar *
gpod_parser_get_channel_description (GpodParser *self);

gchar *
gpod_parser_get_channel_link (GpodParser *self);

gchar *
gpod_parser_get_channel_publish_date (GpodParser *self);

gchar *
gpod_parser_get_channel_enclosure (GpodParser *self);

gchar *
gpod_parser_get_channel_guid (GpodParser *self);

GPtrArray *
gpod_parser_get_channel_items (GpodParser *self);

GpodItem *
gpod_parser_get_channel_item_newest (GpodParser *self);

G_END_DECLS

#endif /* __GPOD_PARSER_H__ */
